<?php

return [

    //通用-关键字
    'keyword' => [
        'keyword|关键字' => 'chsDash|max:100',
    ],

    //通用
    'common' => [
        'keyword|关键字' => 'chsDash|max:100',
        'page|页码' => 'require|number|gt:0',
        'size|每页数量' => 'require|number|elt:100',
    ],

    //登录
    'login' => [
        'mobile|手机号' => 'require|mobile',
        'password|密码' => 'require|max:255',
    ],

    //修改密码
    'changePassword' => [
        'old_password|旧密码' => 'require|min:6|max:200',
        'new_password|新密码' => 'require|min:6|max:200',
        'confirm_password|确认密码' => 'require|confirm:new_password|min:6|max:200',
    ],

    //添加供应商账号
    'addAccount' => [
        'nickname|姓名' => 'require|max:255',
        'mobile|手机号' => 'require|number|length:11|mobile',
        'email|邮箱' => 'email',
    ],

    //修改供应商账号
    'editAccount' => [
        'nickname|姓名' => 'require|max:255',
        'mobile|手机号' => 'require|number|length:11|mobile',
        'email|邮箱' => 'email',
        'old_mobile|原始手机号' => 'require|number|length:11|mobile',
    ],

    //启/禁用 供应商账号
    'statusAccount' => [
        'mobile|手机号' => 'require|number|length:11|mobile',
        'status|状态' => 'require|number|in:' . \app\abutment\model\SupplierUser::$status_normal . ',' . \app\abutment\model\SupplierUser::$status_disabled,
    ],

    //获取分类列表
    'getCatList' => [
        'keyword|关键字' => 'chsDash|max:100',
        'pid|父级分类id' => 'require|number|egt:0',
    ],

    //获取规格值列表
    'getSpecsValueByTitleList' => [
        'spec_id|规格类型id' => 'require|number|gt:0',
    ],

    //获取省市县列表
    'getAreaList' => [
        'level' => 'number|in:1,2,3',
        'pid_code' => 'requireIf:level,2|requireIf:level,3|number|length:6',
    ],


    //创建商品上线申请
    'GoodUpCreate' => [
        'spuCodes|商品编码' => 'require|array|max:10',
        'online_reason|上线原因' => 'require|max:255',
        'online_remark|上线备注' => 'require|max:255',
        'platform_id|平台id' => 'require|number|gt:0',
    ],


];