<?php

namespace app\admin\controller;

use app\admin\model\ChangeLog;
use app\BaseController;
use think\App;
use think\facade\Db;

//品牌
class Brand extends Base
{
    public function __construct(App $app)
    {
        parent::__construct($app);
//        $this->post=$this->request->post();
    }
    public function create(){
        $brand_name=isset( $this->post['brand_name']) && $this->post['brand_name'] !=="" ? trim($this->post['brand_name']):"";
        if($brand_name==""){
            return error_show(1002,"参数brand_name不能为空");
        }

        $brandisT=Db::name("brand")->where(["brand_name"=>$brand_name,"is_del"=>0])->findOrEmpty();
        if(!empty($brandisT))return error_show(1002,"品牌名称已存在");

        $logo_url= isset($this->post['logo_url'])  && $this->post['logo_url'] !=="" ? trim($this->post['logo_url']):"";
//        if($logo_url==""){
//            return error_show(1002,"参数logo_url不能为空");
//        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(102,"创建人数据不存在");
        }

        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"1";

        $data=[
            "brand_name"=>$brand_name,
            "logo_url"=>$logo_url,
            "createrid"=>$createrid,
            "creater"=>$creater,
            "status"=>$status,
            "is_del"=>0,
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $datainfo =Db::name('brand')->insert($data);
        if($datainfo){
            return error_show(0,"新建成功");
        }else{
            return error_show(1002,"新建失败");
        }
    }
    public function list()
    {
        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [["b.is_del", "=", 0]];
        $brand_name = isset($this->post['brand_name']) && $this->post['brand_name'] !== "" ? trim($this->post['brand_name']) : "";
        if ($brand_name !== "") {
            $where[] = ['b.brand_name', "like", "%$brand_name%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !== "" ? intval($this->post['status'])
            : "";
        if ($status !== "") {
            $where[] = ['b.status', "=", $status];
        }
        $creater = isset($this->post['creater']) && $this->post['creater'] !== "" ? trim($this->post['creater']) : "";
        if ($creater !== "") {
            $where[] = ['b.creater', "like", "%$creater%"];
        }
        $start = isset($this->post['start']) && $this->post['start'] !== "" ? $this->post['start'] : "";
        if ($start !== "") {
            $where[] = ['b.addtime', ">=", date('Y-m-d H:i:s', strtotime($start))];
        }
        $end = isset($this->post['end']) && $this->post['end'] !== "" ? $this->post['end'] : "";
        if ($end !== "") {
            $where[] = ['b.addtime', "<", date('Y-m-d H:i:s', strtotime($end) + 24 * 3600)];
        }
        $supplierNo = isset($this->post['supplierNo']) && $this->post['supplierNo'] != "" ? trim($this->post['supplierNo']) : "";
        if($supplierNo!=""){
//            $gyscode = Db::name("supplier")->where(["code"=>$supplierNo])->find();
//            if(empty($gyscode)){
//                return error_show(1004,"未找到供应商信息");
//            }
        $wsmcode = Db::name("brand_book")->where(["gyscode" => $supplierNo, "is_del" => 0])->column("brand_id");
        $where[] = ['b.id', "in", $wsmcode];
    }
        $company_name = isset($this->post['company_name']) && $this->post['company_name'] !== "" ? trim($this->post['company_name']) : "";
        if ($company_name !== "") $where[] = ["b.createrid", 'in', get_company_item_user_by_name($company_name)];

        $count = Db::name('brand')
            ->alias('b')
            ->where($where)
            ->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('brand')
            ->alias('b')
            ->where($where)
            ->page($page,$size)
            ->order("addtime desc,id desc")
            ->select()
            ->toArray();

        $all_createrid = array_column($list,'createrid');
        $item = get_company_name_by_uid($all_createrid);

        foreach ($list as &$val){
            $val['company_name']=$item[$val['createrid']]??'';
        }

        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function edit(){
        $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info = Db::name('brand')->where(['id'=>$id,"is_del"=>0])->find();
        if($info==""){
            return error_show(1003,"未找到数据");
        }
        if($info['status']==1){
            return error_show(1002,"状态是启用状态，无法编辑");
        }
        $brand_name=isset( $this->post['brand_name']) && $this->post['brand_name'] !=="" ? trim($this->post['brand_name']):"";
        if($brand_name==""){
            return error_show(1002,"参数brand_name不能为空");
        }
        $brandisT=Db::name("brand")->where(["brand_name"=>$brand_name,"is_del"=>0])->where("id","<>",$id)
        ->findOrEmpty();
        if(!empty($brandisT))return error_show(1002,"品牌名称已存在");
        $logo_url= isset($this->post['logo_url'])  && $this->post['logo_url'] !=="" ? trim($this->post['logo_url']):"";
//        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
//        if($token==''){
//            return error_show(105,"参数token不能为空");
//        }
//        $user =GetUserInfo($token);
//        if(empty($user)||$user['code']!=0){
//            return error_show(1002,"创建人数据不存在");
//        }
//        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
//        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"0";

        $data=[
            "id"=>$id,
            "brand_name"=>$brand_name,
            "logo_url"=>$logo_url,
            "status"=>$status,
            "is_del"=>0,
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $temp = array_diff($data,$info);
        $json = json_encode($temp,JSON_UNESCAPED_UNICODE);
        $jsp = json_encode($info,JSON_UNESCAPED_UNICODE);
        $item = Db::name("brand")->save($data);
        ChangeLog::logAdd(6,$info['id'],$jsp,$json,['id' => $this->uid, 'nickname' => $this->uname]);
        if($item){
            return error_show(0,"更新成功");
        }else{
            return error_show(1002,"更新失败");
        }
    }
    public function status()
    {
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info =  Db::name("brand")->where([["id","=",$id]])->find();
        if(!$info){
            return error_show(1002,"未找到对应数据");
        }
        $status =  isset($this->post['status']) && $this->post['status']!==""? intval($this->post['status']):"";
        if($status===""){
            return error_show(1002,"参数status不能为空");
        }
        if(!in_array($status,[0,1])){
            return error_show(1002,"参数status无效");
        }
        $info['status']=$status;
        $info['updatetime']=date("Y-m-d H:i:s");
        $msg = $status==1?"启用":"禁用";
        $update = Db::name("brand")->save($info);
        return  $update? error_show(0,"{$msg}成功"):error_show(1004,"{$msg}失败");
    }
    public function del(){
        $id = $this->post['id'] && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id===""){
            return  error_show(1004,"参数id不能为空");
        }
        $str= Db::name('brand')->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($str)){
            return error_show(1002,"未找到数据");
        }
        $end = Db::name('brand')->update(['id'=>$id,'is_del'=>1]);
        if($end){
            return error_show(0,"删除成功");
        }else{
            return error_show(1002,"删除失败");
        }
    }
    public function info(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id=="") return error_show(1002,"参数id不能为空");

        $info =  Db::name("brand")->field('id')->where([["id","=",$id]])->find();
        if(!$info) return error_show(1002, "未找到对应数据");

        $data = Db::name("brand_book")
            ->alias('a')
            ->field("b.logo_url,b.brand_name")
            ->join("brand b","a.brand_id=b.id")
//            ->join("supplier c","c.code= a.gyscode","left")
            ->field("a.creater,a.addtime,a.gyscode")//c.name,c.status
            ->where(['brand_id'=>$info['id']])
            ->findOrEmpty();
        if ($data) {

            $userCommon = \app\admin\common\User::getIns();
            $sinfo = $userCommon->handle('sInfo', ['code' => $data['gyscode']]);
            $data['name'] = $sinfo['data']['name'] ?? '';
            $data['status'] = $sinfo['data']['status'] ?? '';
            return app_show(0, "获取成功", $data);
        } else {
            return app_show(1002, "获取失败", $data);
        }
    }
}