<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

//分类描述信息
class Catdesc extends Base
{
    //public $post="";
    public function __construct(App $app)
    {
        parent::__construct($app);
       // $this->post=$this->request->post();
    }
    public function create(){
        $cat_id = isset($this->post['cat_id']) && $this->post['cat_id'] !==""? intval($this->post['cat_id']):"";
        if($cat_id===""){
            return error_show(1002,"参数cat_id不能为空");
        }
        $desc = isset($this->post['desc']) && $this->post['desc'] !==""? trim($this->post['desc']):"";
        if($desc==""){
            return error_show(1002,"参数desc不能为空");
        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(102,"创建人数据不存在");
        }
        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"0";
         $data =[
             "cat_id"=>$cat_id,
             "desc"=>$desc,
             "status"=>$status,
             "createrid"=>$createrid,
             "creater"=>$creater,
             "addtime"=>date("Y-m-d H:i:s"),
             "updatetime"=>date("Y-m-d H:i:s")
         ];
         $datainfo = Db::name('cat_desc')->insert($data);
         if($datainfo){
             return error_show(0,"新建成功");
         }else{
             return error_show(1002,"新建失败");
         }
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where=[];
        $cat_id = isset($this->post['cat_id']) && $this->post['cat_id'] !=="" ? trim($this->post['cat_id']):"";
        if($cat_id!=""){
            $where[]=['a.cat_id',"=",$cat_id];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!=""){
            $where[]=['a.status',"=",$status];
        }
        $stat = isset($this->post['stat']) && $this->post['stat'] !=="" ? intval($this->post['stat']):"";
        if($stat!=""){
            $where[]=['b.status',"=",$stat];
        }
        $creater = isset($this->post['creater']) && $this->post['creater'] !=="" ? intval($this->post['creater']):"";
        if($creater!=""){
            $where[]=['a.creater',"like","%$creater%"];
        }
        $start = isset($this->post['start']) && $this->post['start']!=="" ? $this->post['start']:"";
        if($start!==""){
            $where[]=['a.addtime',">=",date('Y-m-d H:i:s',strtotime($start))];
        }
        $end = isset($this->post['end']) && $this->post['end']!=="" ? $this->post['end']:"";
        if($end!==""){
            $where[]=['a.addtime',"<",date('Y-m-d H:i:s',strtotime($end)+24*3600)];
        }
        $count = Db::name('cat_desc')->alias('a')->join('cat b',"b.id=a.cat_id","left") ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('cat_desc')->alias('a')->join('wsm_cat b',"b.id=a.cat_id","left")
            ->where($where)->page($page,$size)->order("addtime desc")->field("a.*,b.status as stat")->select();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function status(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info =  Db::name("cat_desc")->where([["id","=",$id]])->find();
        if(!$info){
            return error_show(1002,"未找到对应数据");
        }
        $status =  isset($this->post['status']) && $this->post['status']!==""? intval($this->post['status']):"";
        if($status===""){
            return error_show(1002,"参数status不能为空");
        }
        if(!in_array($status,[0,1])){
            return error_show(1002,"参数status无效");
        }
        $info['status']=$status;
        $info['updatetime']=date("Y-m-d H:i:s");
        $msg = $status==1?"启用":"禁用";
        $update = Db::name("cat_desc")->save($info);
        return  $update? error_show(0,"{$msg}成功"):error_show(1004,"{$msg}失败");
    }
    public function edit(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info = Db::name("cat_desc")->where(['id'=>$id,"is_del"=>0])->find();
        if($info==""){
            return error_show(1002,"未找到数据");
        }
        $cat_id = isset($this->post['cat_id']) && $this->post['cat_id'] !==""? intval($this->post['cat_id']):"";
        if($cat_id===""){
            return error_show(1002,"参数cat_id不能为空");
        }
        $desc = isset($this->post['desc']) && $this->post['desc'] !==""? trim($this->post['desc']):"";
        if($desc==""){
            return error_show(1002,"参数desc不能为空");
        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(102,"创建人数据不存在");
        }
        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"0";
        $data =[
            "id"=>$id,
            "cat_id"=>$cat_id,
            "desc"=>$desc,
            "status"=>$status,
            "createrid"=>$createrid,
            "creater"=>$creater,
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $datatinfo = Db::name("cat_desc")->save($data);
        if($datatinfo){
            return error_show(0,"更新成功");
        }else{
            return error_show(1002,"更新失败");
        }
    }
    public function del(){
        $id = $this->post['id'] && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id===""){
            return  error_show(1004,"参数id不能为空");
        }
        $str= Db::name('cat_desc')->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($str)){
            return error_show(1002,"未找到数据");
        }
        $end = Db::name('cat_desc')->update(['id'=>$id,'is_del'=>1]);
        if($end){
            return error_show(0,"删除成功");
        }else{
            return error_show(1002,"删除失败");
        }
    }
}